(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      7721,        244]
NotebookOptionsPosition[      7476,        231]
NotebookOutlinePosition[      7821,        246]
CellTagsIndexPosition[      7778,        243]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{"c1", "=", 
  RowBox[{
  "Input", "[", 
   "\"\<input matrix C, corresponding to the Finite Jordan Pair\>\"", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"j1", "=", 
  RowBox[{
  "Input", "[", 
   "\"\<input matrix J, corresponding to the Finite Jordan Pair\>\"", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"u", ",", "jnew"}], "}"}], "=", 
   RowBox[{"JordanDecomposition", "[", 
    RowBox[{"Inverse", "[", "j1", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cnew", "=", 
   RowBox[{"c1", ".", "u", ".", "jnew"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cinf", "=", 
   RowBox[{
   "Input", "[", 
    "\"\<Input matrix C.inf, corresponding to the Infinite Jordan Pair\>\"", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"jinf", "=", 
   RowBox[{
   "Input", "[", 
    "\"\<Input matrix J.inf, corresponding to the Infinite Jordan Pair\>\"", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Cpair", "=", 
   RowBox[{"ArrayFlatten", "[", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"cnew", ",", "cinf"}], "}"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"rowsj1", ",", "columnsj1"}], "}"}], "=", 
   RowBox[{"Dimensions", "[", "j1", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"rowsjinf", ",", "columnsjinf"}], "}"}], "=", 
   RowBox[{"Dimensions", "[", "jinf", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Jpair", "=", 
   RowBox[{"ArrayFlatten", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"jnew", ",", 
        RowBox[{"ConstantArray", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"rowsj1", ",", "columnsjinf"}], "}"}]}], "]"}]}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ConstantArray", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"rowsjinf", ",", "columnsj1"}], "}"}]}], "]"}], ",", 
        "jinf"}], "}"}]}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"q", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"rowsC", ",", "columnsC"}], "}"}], "=", 
   RowBox[{"Dimensions", "[", "Cpair", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S", "=", "Cpair"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"While", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"MatrixRank", "[", "S", "]"}], "<", "columnsC"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"q", "=", 
     RowBox[{"q", "+", "1"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"S", "=", 
     RowBox[{"ArrayFlatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "S", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Cpair", ".", 
          RowBox[{"MatrixPower", "[", 
           RowBox[{"Jpair", ",", 
            RowBox[{"q", "-", "1"}]}], "]"}]}], "}"}]}], "}"}], "]"}]}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{
   "Input", "[", 
    "\"\<Choose a value a, other than the f.e.d.'s of the desired system\>\"",
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M", "=", "Cpair"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"i", "=", "1"}], ",", 
   RowBox[{"i", "<", "q"}], ",", 
   RowBox[{"i", "=", 
    RowBox[{"i", "+", "1"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"M", "=", 
    RowBox[{"ArrayFlatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "M", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"Cpair", ".", 
         RowBox[{"MatrixPower", "[", 
          RowBox[{
           RowBox[{"Jpair", "-", 
            RowBox[{"a", " ", 
             RowBox[{"IdentityMatrix", "[", 
              RowBox[{"Dimensions", "[", "Jpair", "]"}], "]"}]}]}], ",", 
           RowBox[{"-", "i"}]}], "]"}]}], "}"}]}], "}"}], "]"}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M", "=", 
   RowBox[{"PseudoInverse", "[", "M", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"rowsM", ",", "columnsM"}], "}"}], "=", 
   RowBox[{"Dimensions", "[", "M", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"step", "=", 
   RowBox[{"columnsM", "/", "q"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"indicator", "=", "1"}], "\[IndentingNewLine]", 
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"i", "=", "1"}], ",", " ", 
   RowBox[{"i", "<=", "q"}], ",", " ", 
   RowBox[{"i", "=", 
    RowBox[{"i", "+", "1"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"v", "[", "i", "]"}], "=", 
     RowBox[{"Take", "[", 
      RowBox[{"M", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "rowsM"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"indicator", ",", 
         RowBox[{"indicator", "+", "step", "-", "1"}]}], "}"}]}], "]"}]}], 
    ";", 
    RowBox[{"indicator", "=", 
     RowBox[{"indicator", "+", "step"}]}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"sum", "=", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"s", "-", "a"}], ")"}], "q"], " ", 
   RowBox[{"v", "[", "1", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"i", "=", "1"}], ",", 
   RowBox[{"i", "<", "q"}], ",", 
   RowBox[{"i", "++"}], ",", 
   RowBox[{"sum", "=", 
    RowBox[{"sum", "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"s", "-", "a"}], ")"}], 
       RowBox[{"q", "-", "i"}]], " ", 
      RowBox[{"v", "[", 
       RowBox[{"i", "+", "1"}], "]"}]}]}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sum", "=", 
   RowBox[{"sum", "//", "Simplify"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"A", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"IdentityMatrix", "[", "rowsC", "]"}], "-", 
    RowBox[{"Cpair", ".", 
     RowBox[{"MatrixPower", "[", 
      RowBox[{
       RowBox[{"Jpair", "-", 
        RowBox[{"a", " ", 
         RowBox[{"IdentityMatrix", "[", 
          RowBox[{"Dimensions", "[", "Jpair", "]"}], "]"}]}]}], ",", 
       RowBox[{"-", "q"}]}], "]"}], ".", "sum"}]}], "//", 
   "Simplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"A", "/.", 
    RowBox[{"s", "\[Rule]", 
     RowBox[{"1", "/", "s"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"A", "=", 
  RowBox[{"A", " ", 
   SuperscriptBox["s", "q"]}]}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJwlz08og3Ecx/Fvu3FDT9pCtpOSizPqyYHkYmq7CImzlGG3H1GKstZqsQMt
l83BTsvaHy2z9NRy4CZJT1IOc3EZF3zfh1+v3p/6Hn7+pdXgikdEAn/vXzHf
/kLqwxZzOIqPcVV20+gUirrP3qiy7WK9yT5jlbSrPtWc2viKsjyHyXn28Dq+
RTC4g74ELh7j+zl3HU06gvLSwvAPBtrKaqxdNdFu3PKynw3i8BB7ehwvUTIT
ODDJPr1GH6GZMnR5n07G6M8Edl2wWzl08uy5K1yoYL6GTgMP7vHpgbvQM+1K
RXvEg5udmEW5jdINlHiRDpVo9wt7Wux9J9f8P4W1umrsO/T2VnW3+nFjTDV7
6i/QsAG1
  "]]
},
WindowSize->{876, 559},
WindowMargins->{{132, Automatic}, {Automatic, 45}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 6915, 209, 675, "Input"]
}
]
*)

(* End of internal cache information *)
